#
# Copyright 2021- daipom
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

require_relative 'hkey_perf_data_reader'
require_relative 'in_windows_exporter'
require 'benchmark'
require 'net/http'

def get_data_from_prometheus_windows_exporter(uri = "http://localhost:9182/metrics")
  response = Net::HTTP.get_response(URI(uri))
  return nil, false unless response.code == "200"

  lines = response.body.split("\n")
    .map { |line| line.strip}
    .select { |line| !line.empty? && !line.start_with?("#") }

  prometheous_records = []

  lines.each do |line|
    record = {
      "name" => "",
      "value" => 0.0,
      "labels" => {},
    }
    i = line.index("{")

    no_label_data = i.nil?
    if no_label_data
      i = line.index(" ")
      record["name"] = line[0..i-1]
      record["value"] = line[i+1..].to_f
    else
      record["name"] = line[0..i-1]
      end_label_i = line.index("}")
      record["value"] = line[end_label_i+1..].to_f
      label = line[i+1..end_label_i-1]
      while true
        i = label.index("=\"")
        break if i.nil?
        key = label[0..i-1]
        end_val_i = label.index("\"", i+2)
        val = label[i+2..end_val_i-1]
        record["labels"][key] = val
        label = label[end_val_i+2..]
        break if label.to_s.empty?
      end
    end

    prometheous_records.append(record)
  end

  return prometheous_records, true
end

def is_same_hash?(h1, h2)
  h1.to_a.map { |k, v| [k.to_s, v] } == h2.to_a.map { |k, v| [k.to_s, v] }
end

a, b = get_data_from_prometheus_windows_exporter

p a.map { |record| record["name"] }

# reader = HKeyPerfDataReader::Reader.new(
#   object_name_whitelist: Fluent::Plugin::HKeyPerfDataWhiteList::NAMES
# )
# result = reader.read
# p result.keys

# 10.times do
#   result = Benchmark.realtime do
#     reader.read
#   end
#   p result
# end

# p "Read RawData by fiddle"

# raw_data_list = []
# 3.times do
#   result = Benchmark.realtime do
#     raw_data_list.append(HKeyPerfDataReader::RawReader.read)
#   end
#   p result
# end

# p "Parse RawData in ruby"

# raw_data_list.each do |raw_data|
#   result = Benchmark.realtime do
#     reader.read(raw_data)
#   end
#   p result
# end

# require 'benchmark'
# require 'uri'
# require 'net/http'

# 10.times do
#   result = Benchmark.realtime do
#     uri = URI("http://localhost:9182/metrics")
#     Net::HTTP.get_response(uri)
#   end
#   p result
# end


# pp result["Memory"].instances[0].counters["Free & Zero Page List Bytes"]
# pp result["Memory"].instances[0].counters["Available Bytes"]
# pp result["Memory"].instances[0].counters["Cache Bytes"]

# p result["Memory"].counters
